diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/propagation/model/three-gpp-propagation-loss-model.cc ns-3.42/src/propagation/model/three-gpp-propagation-loss-model.cc
--- ns-3.41/src/propagation/model/three-gpp-propagation-loss-model.cc	2024-02-09 14:44:08.457794000 -0800
+++ ns-3.42/src/propagation/model/three-gpp-propagation-loss-model.cc	2024-05-29 15:29:47.160073800 -0700
@@ -1387,6 +1552,593 @@
     }
     else
     {
+        NS_FATAL_ERROR("Unknown channel condition");
+    }
+
+    return correlationDistance;
+}
+
+NS_OBJECT_ENSURE_REGISTERED(ThreeGppNTNDenseUrbanPropagationLossModel);
+
+TypeId
+ThreeGppNTNDenseUrbanPropagationLossModel::GetTypeId()
+{
+    static TypeId tid = TypeId("ns3::ThreeGppNTNDenseUrbanPropagationLossModel")
+                            .SetParent<ThreeGppPropagationLossModel>()
+                            .SetGroupName("Propagation")
+                            .AddConstructor<ThreeGppNTNDenseUrbanPropagationLossModel>();
+    return tid;
+}
+
+ThreeGppNTNDenseUrbanPropagationLossModel::ThreeGppNTNDenseUrbanPropagationLossModel()
+    : ThreeGppPropagationLossModel(),
+      m_SFCL_DenseUrban(&SFCL_DenseUrban)
+{
+    NS_LOG_FUNCTION(this);
+    m_channelConditionModel = CreateObject<ThreeGppNTNDenseUrbanChannelConditionModel>();
+}
+
+ThreeGppNTNDenseUrbanPropagationLossModel::~ThreeGppNTNDenseUrbanPropagationLossModel()
+{
+    NS_LOG_FUNCTION(this);
+}
+
+double
+ThreeGppNTNDenseUrbanPropagationLossModel::GetO2iDistance2dIn() const
+{
+    abort();
+}
+
+double
+ThreeGppNTNDenseUrbanPropagationLossModel::GetLossLos(Ptr<MobilityModel> a,
+                                                      Ptr<MobilityModel> b) const
+{
+    NS_LOG_FUNCTION(this);
+    NS_ASSERT_MSG(m_frequency <= 100.0e9,
+                  "NTN communications are valid for frequencies between 0.5 and 100 GHz.");
+
+    double distance3D = CalculateDistance(a->GetPosition(), b->GetPosition());
+    auto [elevAngle, elevAngleQuantized] =
+        ThreeGppChannelConditionModel::GetQuantizedElevationAngle(a, b);
+
+    // compute the pathloss (see 3GPP TR 38.811, Table 6.6.2)
+    double loss = ComputeNtnPathloss(m_frequency, distance3D);
+
+    // Apply Atmospheric Absorption Loss 3GPP 38.811 6.6.4
+    loss += ComputeAtmosphericAbsorptionLoss(m_frequency, elevAngle);
+
+    // Apply Ionospheric plus Tropospheric Scintillation Loss
+    loss += ComputeIonosphericPlusTroposphericScintillationLoss(m_frequency, elevAngleQuantized);
+
+    NS_LOG_DEBUG("Loss " << loss);
+    return loss;
+}
+
+double
+ThreeGppNTNDenseUrbanPropagationLossModel::GetLossNlos(Ptr<MobilityModel> a,
+                                                       Ptr<MobilityModel> b) const
+{
+    NS_LOG_FUNCTION(this);
+    NS_ASSERT_MSG(m_frequency <= 100.0e9,
+                  "NTN communications are valid for frequencies between 0.5 and 100 GHz.");
+
+    double distance3D = CalculateDistance(a->GetPosition(), b->GetPosition());
+    auto [elevAngle, elevAngleQuantized] =
+        ThreeGppChannelConditionModel::GetQuantizedElevationAngle(a, b);
+
+    // compute the pathloss (see 3GPP TR 38.811, Table 6.6.2)
+    double loss = ComputeNtnPathloss(m_frequency, distance3D);
+
+    // Apply Clutter Loss
+    loss += ComputeClutterLoss(m_frequency, m_SFCL_DenseUrban, elevAngleQuantized);
+
+    // Apply Atmospheric Absorption Loss 3GPP 38.811 6.6.4
+    loss += ComputeAtmosphericAbsorptionLoss(m_frequency, elevAngle);
+
+    // Apply Ionospheric plus Tropospheric Scintillation Loss
+    loss += ComputeIonosphericPlusTroposphericScintillationLoss(m_frequency, elevAngleQuantized);
+
+    NS_LOG_DEBUG("Loss " << loss);
+    return loss;
+}
+
+double
+ThreeGppNTNDenseUrbanPropagationLossModel::GetShadowingStd(
+    Ptr<MobilityModel> a,
+    Ptr<MobilityModel> b,
+    ChannelCondition::LosConditionValue cond) const
+{
+    NS_LOG_FUNCTION(this);
+    double shadowingStd;
+
+    std::string freqBand = (m_frequency < 13.0e9) ? "S" : "Ka";
+    auto [elevAngle, elevAngleQuantized] =
+        ThreeGppChannelConditionModel::GetQuantizedElevationAngle(a, b);
+
+    // Assign Shadowing Standard Deviation according to table 6.6.2-1
+    if (cond == ChannelCondition::LosConditionValue::LOS && freqBand == "S")
+    {
+        shadowingStd = (*m_SFCL_DenseUrban).at(elevAngleQuantized)[SFCL_params::S_LOS_sigF];
+    }
+    else if (cond == ChannelCondition::LosConditionValue::LOS && freqBand == "Ka")
+    {
+        shadowingStd = (*m_SFCL_DenseUrban).at(elevAngleQuantized)[SFCL_params::Ka_LOS_sigF];
+    }
+    else if (cond == ChannelCondition::LosConditionValue::NLOS && freqBand == "S")
+    {
+        shadowingStd = (*m_SFCL_DenseUrban).at(elevAngleQuantized)[SFCL_params::S_NLOS_sigF];
+    }
+    else if (cond == ChannelCondition::LosConditionValue::NLOS && freqBand == "Ka")
+    {
+        shadowingStd = (*m_SFCL_DenseUrban).at(elevAngleQuantized)[SFCL_params::Ka_NLOS_sigF];
+    }
+    else
+    {
+        NS_FATAL_ERROR("Unknown channel condition");
+    }
+
+    return shadowingStd;
+}
+
+double
+ThreeGppNTNDenseUrbanPropagationLossModel::GetShadowingCorrelationDistance(
+    ChannelCondition::LosConditionValue cond) const
+{
+    NS_LOG_FUNCTION(this);
+    double correlationDistance;
+
+    // See 3GPP TR 38.811, Table 6.7.2-1a/b and Table 6.7.2-2a/b
+    if (cond == ChannelCondition::LosConditionValue::LOS)
+    {
+        correlationDistance = 37;
+    }
+    else if (cond == ChannelCondition::LosConditionValue::NLOS)
+    {
+        correlationDistance = 50;
+    }
+    else
+    {
+        NS_FATAL_ERROR("Unknown channel condition");
+    }
+
+    return correlationDistance;
+}
+
+// ------------------------------------------------------------------------- //
+
+NS_OBJECT_ENSURE_REGISTERED(ThreeGppNTNUrbanPropagationLossModel);
+
+TypeId
+ThreeGppNTNUrbanPropagationLossModel::GetTypeId()
+{
+    static TypeId tid = TypeId("ns3::ThreeGppNTNUrbanPropagationLossModel")
+                            .SetParent<ThreeGppPropagationLossModel>()
+                            .SetGroupName("Propagation")
+                            .AddConstructor<ThreeGppNTNUrbanPropagationLossModel>();
+    return tid;
+}
+
+ThreeGppNTNUrbanPropagationLossModel::ThreeGppNTNUrbanPropagationLossModel()
+    : ThreeGppPropagationLossModel(),
+      m_SFCL_Urban(&SFCL_Urban)
+{
+    NS_LOG_FUNCTION(this);
+    m_channelConditionModel = CreateObject<ThreeGppNTNUrbanChannelConditionModel>();
+}
+
+ThreeGppNTNUrbanPropagationLossModel::~ThreeGppNTNUrbanPropagationLossModel()
+{
+    NS_LOG_FUNCTION(this);
+}
+
+double
+ThreeGppNTNUrbanPropagationLossModel::GetO2iDistance2dIn() const
+{
+    abort();
+}
+
+double
+ThreeGppNTNUrbanPropagationLossModel::GetLossLos(Ptr<MobilityModel> a, Ptr<MobilityModel> b) const
+{
+    NS_LOG_FUNCTION(this);
+    NS_ASSERT_MSG(m_frequency <= 100.0e9,
+                  "NTN communications are valid for frequencies between 0.5 and 100 GHz.");
+
+    double distance3D = CalculateDistance(a->GetPosition(), b->GetPosition());
+    auto [elevAngle, elevAngleQuantized] =
+        ThreeGppChannelConditionModel::GetQuantizedElevationAngle(a, b);
+
+    // compute the pathloss (see 3GPP TR 38.811, Table 6.6.2)
+    double loss = ComputeNtnPathloss(m_frequency, distance3D);
+
+    // Apply Atmospheric Absorption Loss 3GPP 38.811 6.6.4
+    loss += ComputeAtmosphericAbsorptionLoss(m_frequency, elevAngle);
+
+    // Apply Ionospheric plus Tropospheric Scintillation Loss
+    loss += ComputeIonosphericPlusTroposphericScintillationLoss(m_frequency, elevAngleQuantized);
+
+    NS_LOG_DEBUG("Loss " << loss);
+    return loss;
+}
+
+double
+ThreeGppNTNUrbanPropagationLossModel::GetLossNlos(Ptr<MobilityModel> a, Ptr<MobilityModel> b) const
+{
+    NS_LOG_FUNCTION(this);
+    NS_ASSERT_MSG(m_frequency <= 100.0e9,
+                  "NTN communications are valid for frequencies between 0.5 and 100 GHz.");
+
+    double distance3D = CalculateDistance(a->GetPosition(), b->GetPosition());
+    auto [elevAngle, elevAngleQuantized] =
+        ThreeGppChannelConditionModel::GetQuantizedElevationAngle(a, b);
+
+    // compute the pathloss (see 3GPP TR 38.811, Table 6.6.2)
+    double loss = ComputeNtnPathloss(m_frequency, distance3D);
+
+    // Apply Clutter Loss
+    loss += ComputeClutterLoss(m_frequency, m_SFCL_Urban, elevAngleQuantized);
+
+    // Apply Atmospheric Absorption Loss 3GPP 38.811 6.6.4
+    loss += ComputeAtmosphericAbsorptionLoss(m_frequency, elevAngle);
+
+    // Apply Ionospheric plus Tropospheric Scintillation Loss
+    loss += ComputeIonosphericPlusTroposphericScintillationLoss(m_frequency, elevAngleQuantized);
+
+    NS_LOG_DEBUG("Loss " << loss);
+    return loss;
+}
+
+double
+ThreeGppNTNUrbanPropagationLossModel::GetShadowingStd(
+    Ptr<MobilityModel> a,
+    Ptr<MobilityModel> b,
+    ChannelCondition::LosConditionValue cond) const
+{
+    NS_LOG_FUNCTION(this);
+    double shadowingStd;
+
+    std::string freqBand = (m_frequency < 13.0e9) ? "S" : "Ka";
+    auto [elevAngle, elevAngleQuantized] =
+        ThreeGppChannelConditionModel::GetQuantizedElevationAngle(a, b);
+
+    // Assign Shadowing Standard Deviation according to table 6.6.2-1
+    if (cond == ChannelCondition::LosConditionValue::LOS && freqBand == "S")
+    {
+        shadowingStd = (*m_SFCL_Urban).at(elevAngleQuantized)[SFCL_params::S_LOS_sigF];
+    }
+    else if (cond == ChannelCondition::LosConditionValue::LOS && freqBand == "Ka")
+    {
+        shadowingStd = (*m_SFCL_Urban).at(elevAngleQuantized)[SFCL_params::Ka_LOS_sigF];
+    }
+    else if (cond == ChannelCondition::LosConditionValue::NLOS && freqBand == "S")
+    {
+        shadowingStd = (*m_SFCL_Urban).at(elevAngleQuantized)[SFCL_params::S_NLOS_sigF];
+    }
+    else if (cond == ChannelCondition::LosConditionValue::NLOS && freqBand == "Ka")
+    {
+        shadowingStd = (*m_SFCL_Urban).at(elevAngleQuantized)[SFCL_params::Ka_NLOS_sigF];
+    }
+    else
+    {
+        NS_FATAL_ERROR("Unknown channel condition");
+    }
+
+    return shadowingStd;
+}
+
+double
+ThreeGppNTNUrbanPropagationLossModel::GetShadowingCorrelationDistance(
+    ChannelCondition::LosConditionValue cond) const
+{
+    NS_LOG_FUNCTION(this);
+    double correlationDistance;
+
+    // See 3GPP TR 38.811, Table 6.7.2-3a/b and Table 6.7.2-3a/b
+    if (cond == ChannelCondition::LosConditionValue::LOS)
+    {
+        correlationDistance = 37;
+    }
+    else if (cond == ChannelCondition::LosConditionValue::NLOS)
+    {
+        correlationDistance = 50;
+    }
+    else
+    {
+        NS_FATAL_ERROR("Unknown channel condition");
+    }
+
+    return correlationDistance;
+}
+
+// ------------------------------------------------------------------------- //
+
+NS_OBJECT_ENSURE_REGISTERED(ThreeGppNTNSuburbanPropagationLossModel);
+
+TypeId
+ThreeGppNTNSuburbanPropagationLossModel::GetTypeId()
+{
+    static TypeId tid = TypeId("ns3::ThreeGppNTNSuburbanPropagationLossModel")
+                            .SetParent<ThreeGppPropagationLossModel>()
+                            .SetGroupName("Propagation")
+                            .AddConstructor<ThreeGppNTNSuburbanPropagationLossModel>();
+    return tid;
+}
+
+ThreeGppNTNSuburbanPropagationLossModel::ThreeGppNTNSuburbanPropagationLossModel()
+    : ThreeGppPropagationLossModel(),
+      m_SFCL_SuburbanRural(&SFCL_SuburbanRural)
+{
+    NS_LOG_FUNCTION(this);
+    m_channelConditionModel = CreateObject<ThreeGppNTNSuburbanChannelConditionModel>();
+}
+
+ThreeGppNTNSuburbanPropagationLossModel::~ThreeGppNTNSuburbanPropagationLossModel()
+{
+    NS_LOG_FUNCTION(this);
+}
+
+double
+ThreeGppNTNSuburbanPropagationLossModel::GetO2iDistance2dIn() const
+{
+    abort();
+}
+
+double
+ThreeGppNTNSuburbanPropagationLossModel::GetLossLos(Ptr<MobilityModel> a,
+                                                    Ptr<MobilityModel> b) const
+{
+    NS_LOG_FUNCTION(this);
+    NS_ASSERT_MSG(m_frequency <= 100.0e9,
+                  "NTN communications are valid for frequencies between 0.5 and 100 GHz.");
+
+    double distance3D = CalculateDistance(a->GetPosition(), b->GetPosition());
+    auto [elevAngle, elevAngleQuantized] =
+        ThreeGppChannelConditionModel::GetQuantizedElevationAngle(a, b);
+
+    // compute the pathloss (see 3GPP TR 38.811, Table 6.6.2)
+    double loss = ComputeNtnPathloss(m_frequency, distance3D);
+
+    // Apply Atmospheric Absorption Loss 3GPP 38.811 6.6.4
+    loss += ComputeAtmosphericAbsorptionLoss(m_frequency, elevAngle);
+
+    // Apply Ionospheric plus Tropospheric Scintillation Loss
+    loss += ComputeIonosphericPlusTroposphericScintillationLoss(m_frequency, elevAngleQuantized);
+
+    NS_LOG_DEBUG("Loss " << loss);
+
+    return loss;
+}
+
+double
+ThreeGppNTNSuburbanPropagationLossModel::GetLossNlos(Ptr<MobilityModel> a,
+                                                     Ptr<MobilityModel> b) const
+{
+    NS_LOG_FUNCTION(this);
+    NS_ASSERT_MSG(m_frequency <= 100.0e9,
+                  "NTN communications are valid for frequencies between 0.5 and 100 GHz.");
+
+    double distance3D = CalculateDistance(a->GetPosition(), b->GetPosition());
+    auto [elevAngle, elevAngleQuantized] =
+        ThreeGppChannelConditionModel::GetQuantizedElevationAngle(a, b);
+
+    // compute the pathloss (see 3GPP TR 38.811, Table 6.6.2)
+    double loss = ComputeNtnPathloss(m_frequency, distance3D);
+
+    // Apply Clutter Loss
+    loss += ComputeClutterLoss(m_frequency, m_SFCL_SuburbanRural, elevAngleQuantized);
+
+    // Apply Atmospheric Absorption Loss 3GPP 38.811 6.6.4
+    loss += ComputeAtmosphericAbsorptionLoss(m_frequency, elevAngle);
+
+    // Apply Ionospheric plus Tropospheric Scintillation Loss
+    loss += ComputeIonosphericPlusTroposphericScintillationLoss(m_frequency, elevAngleQuantized);
+
+    NS_LOG_DEBUG("Loss " << loss);
+    return loss;
+}
+
+double
+ThreeGppNTNSuburbanPropagationLossModel::GetShadowingStd(
+    Ptr<MobilityModel> a,
+    Ptr<MobilityModel> b,
+    ChannelCondition::LosConditionValue cond) const
+{
+    NS_LOG_FUNCTION(this);
+    double shadowingStd;
+
+    std::string freqBand = (m_frequency < 13.0e9) ? "S" : "Ka";
+    auto [elevAngle, elevAngleQuantized] =
+        ThreeGppChannelConditionModel::GetQuantizedElevationAngle(a, b);
+
+    // Assign Shadowing Standard Deviation according to table 6.6.2-1
+    if (cond == ChannelCondition::LosConditionValue::LOS && freqBand == "S")
+    {
+        shadowingStd = (*m_SFCL_SuburbanRural).at(elevAngleQuantized)[SFCL_params::S_LOS_sigF];
+    }
+    else if (cond == ChannelCondition::LosConditionValue::LOS && freqBand == "Ka")
+    {
+        shadowingStd = (*m_SFCL_SuburbanRural).at(elevAngleQuantized)[SFCL_params::Ka_LOS_sigF];
+    }
+    else if (cond == ChannelCondition::LosConditionValue::NLOS && freqBand == "S")
+    {
+        shadowingStd = (*m_SFCL_SuburbanRural).at(elevAngleQuantized)[SFCL_params::S_NLOS_sigF];
+    }
+    else if (cond == ChannelCondition::LosConditionValue::NLOS && freqBand == "Ka")
+    {
+        shadowingStd = (*m_SFCL_SuburbanRural).at(elevAngleQuantized)[SFCL_params::Ka_NLOS_sigF];
+    }
+    else
+    {
+        NS_FATAL_ERROR("Unknown channel condition");
+    }
+
+    return shadowingStd;
+}
+
+double
+ThreeGppNTNSuburbanPropagationLossModel::GetShadowingCorrelationDistance(
+    ChannelCondition::LosConditionValue cond) const
+{
+    NS_LOG_FUNCTION(this);
+    double correlationDistance;
+
+    // See 3GPP TR 38.811, Table 6.7.2-5a/b and Table 6.7.2-6a/b
+    if (cond == ChannelCondition::LosConditionValue::LOS)
+    {
+        correlationDistance = 37;
+    }
+    else if (cond == ChannelCondition::LosConditionValue::NLOS)
+    {
+        correlationDistance = 50;
+    }
+    else
+    {
+        NS_FATAL_ERROR("Unknown channel condition");
+    }
+
+    return correlationDistance;
+}
+
+// ------------------------------------------------------------------------- //
+
+NS_OBJECT_ENSURE_REGISTERED(ThreeGppNTNRuralPropagationLossModel);
+
+TypeId
+ThreeGppNTNRuralPropagationLossModel::GetTypeId()
+{
+    static TypeId tid = TypeId("ns3::ThreeGppNTNRuralPropagationLossModel")
+                            .SetParent<ThreeGppPropagationLossModel>()
+                            .SetGroupName("Propagation")
+                            .AddConstructor<ThreeGppNTNRuralPropagationLossModel>();
+    return tid;
+}
+
+ThreeGppNTNRuralPropagationLossModel::ThreeGppNTNRuralPropagationLossModel()
+    : ThreeGppPropagationLossModel(),
+      m_SFCL_SuburbanRural(&SFCL_SuburbanRural)
+{
+    NS_LOG_FUNCTION(this);
+    m_channelConditionModel = CreateObject<ThreeGppNTNRuralChannelConditionModel>();
+}
+
+ThreeGppNTNRuralPropagationLossModel::~ThreeGppNTNRuralPropagationLossModel()
+{
+    NS_LOG_FUNCTION(this);
+}
+
+double
+ThreeGppNTNRuralPropagationLossModel::GetO2iDistance2dIn() const
+{
+    abort();
+}
+
+double
+ThreeGppNTNRuralPropagationLossModel::GetLossLos(Ptr<MobilityModel> a, Ptr<MobilityModel> b) const
+{
+    NS_LOG_FUNCTION(this);
+    NS_ASSERT_MSG(m_frequency <= 100.0e9,
+                  "NTN communications are valid for frequencies between 0.5 and 100 GHz.");
+
+    double distance3D = CalculateDistance(a->GetPosition(), b->GetPosition());
+    auto [elevAngle, elevAngleQuantized] =
+        ThreeGppChannelConditionModel::GetQuantizedElevationAngle(a, b);
+
+    // compute the pathloss (see 3GPP TR 38.811, Table 6.6.2)
+    double loss = ComputeNtnPathloss(m_frequency, distance3D);
+
+    // Apply Atmospheric Absorption Loss 3GPP 38.811 6.6.4
+    loss += ComputeAtmosphericAbsorptionLoss(m_frequency, elevAngle);
+
+    // Apply Ionospheric plus Tropospheric Scintillation Loss
+    loss += ComputeIonosphericPlusTroposphericScintillationLoss(m_frequency, elevAngleQuantized);
+
+    NS_LOG_DEBUG("Loss " << loss);
+    return loss;
+}
+
+double
+ThreeGppNTNRuralPropagationLossModel::GetLossNlos(Ptr<MobilityModel> a, Ptr<MobilityModel> b) const
+{
+    NS_LOG_FUNCTION(this);
+    NS_ASSERT_MSG(m_frequency <= 100.0e9,
+                  "NTN communications are valid for frequencies between 0.5 and 100 GHz.");
+
+    double distance3D = CalculateDistance(a->GetPosition(), b->GetPosition());
+    auto [elevAngle, elevAngleQuantized] =
+        ThreeGppChannelConditionModel::GetQuantizedElevationAngle(a, b);
+
+    // compute the pathloss (see 3GPP TR 38.811, Table 6.6.2)
+    double loss = ComputeNtnPathloss(m_frequency, distance3D);
+
+    // Apply Clutter Loss
+    loss += ComputeClutterLoss(m_frequency, m_SFCL_SuburbanRural, elevAngleQuantized);
+
+    // Apply Atmospheric Absorption Loss 3GPP 38.811 6.6.4
+    loss += ComputeAtmosphericAbsorptionLoss(m_frequency, elevAngle);
+
+    // Apply Ionospheric plus Tropospheric Scintillation Loss
+    loss += ComputeIonosphericPlusTroposphericScintillationLoss(m_frequency, elevAngleQuantized);
+
+    NS_LOG_DEBUG("Loss " << loss);
+    return loss;
+}
+
+double
+ThreeGppNTNRuralPropagationLossModel::GetShadowingStd(
+    Ptr<MobilityModel> a,
+    Ptr<MobilityModel> b,
+    ChannelCondition::LosConditionValue cond) const
+{
+    NS_LOG_FUNCTION(this);
+    double shadowingStd;
+
+    std::string freqBand = (m_frequency < 13.0e9) ? "S" : "Ka";
+    auto [elevAngle, elevAngleQuantized] =
+        ThreeGppChannelConditionModel::GetQuantizedElevationAngle(a, b);
+
+    // Assign Shadowing Standard Deviation according to table 6.6.2-1
+    if (cond == ChannelCondition::LosConditionValue::LOS && freqBand == "S")
+    {
+        shadowingStd = (*m_SFCL_SuburbanRural).at(elevAngleQuantized)[SFCL_params::S_LOS_sigF];
+    }
+    else if (cond == ChannelCondition::LosConditionValue::LOS && freqBand == "Ka")
+    {
+        shadowingStd = (*m_SFCL_SuburbanRural).at(elevAngleQuantized)[SFCL_params::Ka_LOS_sigF];
+    }
+    else if (cond == ChannelCondition::LosConditionValue::NLOS && freqBand == "S")
+    {
+        shadowingStd = (*m_SFCL_SuburbanRural).at(elevAngleQuantized)[SFCL_params::S_NLOS_sigF];
+    }
+    else if (cond == ChannelCondition::LosConditionValue::NLOS && freqBand == "Ka")
+    {
+        shadowingStd = (*m_SFCL_SuburbanRural).at(elevAngleQuantized)[SFCL_params::Ka_NLOS_sigF];
+    }
+    else
+    {
+        NS_FATAL_ERROR("Unknown channel condition");
+    }
+
+    return shadowingStd;
+}
+
+double
+ThreeGppNTNRuralPropagationLossModel::GetShadowingCorrelationDistance(
+    ChannelCondition::LosConditionValue cond) const
+{
+    NS_LOG_FUNCTION(this);
+    double correlationDistance;
+
+    // See 3GPP TR 38.811, Table 6.7.2-7a/b and Table 6.7.2-8a/b
+    if (cond == ChannelCondition::LosConditionValue::LOS)
+    {
+        correlationDistance = 37;
+    }
+    else if (cond == ChannelCondition::LosConditionValue::NLOS)
+    {
+        correlationDistance = 120;
+    }
+    else
+    {
         NS_FATAL_ERROR("Unknown channel condition");
     }
 
